﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using HeuristicLab.Common;
using HeuristicLab.Core;
using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;

namespace HeuristicLab.Problems.TradeRules
{
    [StorableClass]
    [Item("BoolConstant", "Represents a BoolConstant value.")]
    public sealed class BoolConstant : Symbol
    {
        private const int minimumArity = 0;
        private const int maximumArity = 0;

        public override int MinimumArity
        {
            get { return minimumArity; }
        }
        public override int MaximumArity
        {
            get { return maximumArity; }
        }


        [StorableConstructor]
        private BoolConstant(bool deserializing) : base(deserializing) { }
        private BoolConstant(BoolConstant original, Cloner cloner)
            : base(original, cloner)
        {
        }
        public BoolConstant()
            : base("BoolConstant", "Represents a BoolConstant value.")
        {
        }

        public override ISymbolicExpressionTreeNode CreateTreeNode()
        {
            return new BoolConstantTreeNode(this);
        }

        public override IDeepCloneable Clone(Cloner cloner)
        {
            return new BoolConstant(this, cloner);
        }
    }
}